local Orig_CombatText_AddMessage


-- prevent standard reflect combat message showing
function SpellBlocked_CombatText_AddMessage(message, ...)
	if message ~= REFLECT then
		Orig_CombatText_AddMessage(message, ...)
	end
end


function SpellBlocked_OnEvent(self, event, ...)
	if event == "COMBAT_LOG_EVENT_UNFILTERED" then
		if select(6, ...) == UnitGUID("player") and select(2, ...) == "SPELL_MISSED" and select(12, ...) == "REFLECT" and SHOW_COMBAT_TEXT == "1" then
			-- print our own combat message with the spell name included
			CombatText_AddMessage(REFLECT.. " "..select(10, ...), COMBAT_TEXT_SCROLL_FUNCTION, 1, 1, 1)
		end
	elseif event == "ADDON_LOADED" and select(1, ...) == "Blizzard_CombatText" then
		-- hook CombatText_AddMessage so we can make our own
		Orig_CombatText_AddMessage = CombatText_AddMessage
		CombatText_AddMessage = SpellBlocked_CombatText_AddMessage
	end
end


local frame = CreateFrame("Frame")
frame:SetScript("OnEvent", SpellBlocked_OnEvent)
frame:RegisterEvent("ADDON_LOADED")
frame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")